#include <jo/jo.h>
#include <SEGA_INT.H>

#include "ZT/ZT_COMMON.h"
#include "render.h"
#include "tga.h"
#include "anidefs.h"

#include <sddrvs.dat>
#define draw_distance (800)
const char map[] = {0xff, 0xff, 0xff, 0xff}; //For sound driver

entity_t testEnt;
entity_t otherEnt;

//
// Game data //
//Be very careful with uninitialized pointers. [In other words, INITIALIZE POINTERS!]
//Discovery: the MC68EC00 in the Saturn is a .. 68k. I tell people its 32-bit, but.. is it really? no, dont think so
//


	jo_camera rcam;

void	initCamera(jo_camera * curCam)
{
	(*curCam).viewpoint[X] = (0.0);
	(*curCam).viewpoint[Y] = (0.0);
	(*curCam).viewpoint[Z] = 65536;
	(*curCam).z_angle = DEGtoANG(0.0);
	(*curCam).target[X] = 0;
	(*curCam).target[Y] = 0;
	(*curCam).target[Z] = 0;
	slWindow(0, 0, JO_TV_WIDTH-1, JO_TV_HEIGHT-1, draw_distance, JO_TV_WIDTH_2, JO_TV_HEIGHT_2);
	slZdspLevel(3);
	slPerspective(DEGtoANG(120)); //FOV ??
}



		ANGLE tgt[XYZ] = {0, 0, 0};
		int polcnt = 0;
		FIXED lightSrc[4] = {0, 65536, 0, 0};

void	draw(void){
	
		slPushMatrix();
		slTranslate(0, 0, tgt[Z]<<16);
		slRotX((tgt[X]));
		slRotY((tgt[Y]));
		slRotZ(0);
/* 		//ssh2DrawModel(&testEnt, lightSrc);
		for(int i = 0; i < (polcnt>>2); i++)
			{
				slTranslate(12<<16, 0, 0);
				//ssh2DrawModel(&testEnt, lightSrc);
				ssh2DrawAnimation(&testEnt, &run, lightSrc);
			} */
				slTranslate(12<<16, 0, 0);
				ssh2DrawAnimation(&testEnt, &forward, lightSrc);
				slTranslate(12<<16, 0, 0);
				ssh2DrawAnimation(&testEnt, &run, lightSrc);
				slTranslate(12<<16, 0, 0);
				ssh2DrawAnimation(&testEnt, &dbound, lightSrc);
				slTranslate(12<<16, 0, 0);
				ssh2DrawAnimation(&testEnt, &idle, lightSrc);
		slPopMatrix();
		
}


		MATRIX msMatrix;

void	running_frame(void)
{
	do{
	vdp2_CRAMoffset[1] = 16; //Moves SPR layer color banks up in color RAM by 256 entries.
		frame_render_prep();
		
		slSlaveFunc(draw,0);
		slCashPurge();
	
		slUnitMatrix(msMatrix);
		msMatrix[3][Z] = tgt[Z]<<16;
		msh2DrawModel(&testEnt, msMatrix, lightSrc);

		slSlaveFunc(sort_master_polys, 0);

		if(jo_is_pad1_key_pressed(JO_KEY_UP)) tgt[X]+=128;
		if(jo_is_pad1_key_pressed(JO_KEY_DOWN)) tgt[X]-=128;
		
		if(jo_is_pad1_key_pressed(JO_KEY_A)) tgt[Z]+=1;
		if(jo_is_pad1_key_pressed(JO_KEY_X)) tgt[Z]-=1;
		
		if(jo_is_pad1_key_pressed(JO_KEY_Z)) polcnt+=1;
		if(jo_is_pad1_key_pressed(JO_KEY_C)) polcnt-=1;
		
		if(jo_is_pad1_key_pressed(JO_KEY_RIGHT)) tgt[Y]+=128;
		if(jo_is_pad1_key_pressed(JO_KEY_LEFT)) tgt[Y]-=128;

		update_gamespeed();
		slSynch();
		
		jo_printf(0, 5, "(%i SENT)", ssh2SentPolys[0] + msh2SentPolys[0]);
		jo_printf(0, 6, "(%i PCLP)", polcnt);
		jo_printf(0, 7, "(%i TV)", transVerts[0]);
		jo_printf(0, 8, "(%i TP)", transPolys[0]);
		
	} while(true);
}

void	jo_main(void)
{

	jo_core_init(0xE726); //Teal Color is the value
	slDynamicFrame(ON); //Dynamic framerate
	slColRAMMode(2); //Set 24bpp
	slZoomNbg0(32768, 32768); //Set 2x Zoom-in
    SynchConst=(Sint8)2;  //Framerate control. 1/60 = 60 FPS, 2/60 = 30 FPS, etc.
    framerate=2;
	initCamera(&rcam);
	//Loading Area
	slInitSound((unsigned char *)sddrvstsk, sizeof(sddrvstsk), (unsigned char *)map, sizeof(map));

	ztLoad3Dmodel((Sint8*)"BPONY.ZTP", jo_malloc(102400), &testEnt, false);
	currentAddress = ztLoad3Dmodel((Sint8*)"BPONY.ZTP", currentAddress, &otherEnt, false);
	
	get_file_in_memory((Sint8*)"TADA.TGA", (void*)currentAddress);
	read_tga_in_memory((void*)currentAddress);
	set_tga_as_palette();
	
	WRAP_NewTexture((Sint8*)"FLAT.TGA", (void*)currentAddress);
	WRAP_NewTexture((Sint8*)"MANE.TGA", (void*)currentAddress);
	WRAP_NewTexture((Sint8*)"TAIL.TGA", (void*)currentAddress);
	WRAP_NewTexture((Sint8*)"LEYE.TGA", (void*)currentAddress);
	WRAP_NewTexture((Sint8*)"REYE.TGA", (void*)currentAddress);
	WRAP_NewTexture((Sint8*)"NOSE.TGA", (void*)currentAddress);
	
	init_render_area();
	
	jo_printf(0, 20, "(press A)");
	
	anim_defs();
	running_frame();
}

