#ifndef __RENDER_H__
# define __RENDER_H__

#include "jo/jo.h"
#include "ZT/ZT_COMMON.h"
#include "tga.h"
#include "timsort.h"

typedef struct{
    POINT  pnt;
    int clipFlag;
    FIXED  inverseZ;
} vertex_t; //20 bytes each

typedef struct
{
	char uniform;
	Uint8 arate[256];
    Uint16 currentFrm;
    Uint8 currentKeyFrm;
    Uint8 startFrm;
    Uint8 endFrm;
} animationControl;

extern int * ssh2SentPolys;
extern int * msh2SentPolys;
extern int * transVerts;
extern int * transPolys;

extern FIXED outTime;
extern FIXED lasttime;
extern Sint32 framerate;
extern Sint8 SynchConst;

extern unsigned short * vdp2_CRAMoffset;

extern FIXED MsScreenDist;
extern FIXED MsZlimit;

void	init_render_area(void);
void	frame_render_prep(void);
void	update_gamespeed(void);
void	ssh2DrawModel(entity_t * ent, FIXED * lightSrc);
void	msh2DrawModel(entity_t * ent, MATRIX msMatrix, FIXED * lightSrc);
void	ssh2DrawAnimation(entity_t * ent, animationControl * animCtrl, FIXED * lightSrc);
void	sort_master_polys(void);
#endif

